package Tetris;

import java.awt.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Stein {
    SteineTyp Block;
    private int x = 4, y = -2;
    private int normal = 850;
    private int fast = 50;
    private int rotation;
    private long beginTime;
    private int delayTime = normal;
    private int deltax = 0;
    private boolean collision = false;
    private int size;

    public static final int BOARD_WIDTH = 11;
    public static final int BOARD_HEIGHT = 20;
    public static final int BLOCK_SIZE = 30;

    private int[][] coords;
    private Board board;
    private Color color;

    public Stein() {
       /* this.coords = coords;
        this.board = board;
        this.color = color;*/
        //Ewen Kerbs still in progress
        // Hier werden die verschiedene steine auf deren typ "analysiert" und dann ausgewertet wie viel platz die aufm spielbrett benötigen
        Block = SteineTyp.randomSteine();
        switch (Block)
        {
            case I:
                size = 4;
                break;
            case O:
                size =2;
                break;
            default:
                size =3;
                break;
        }
    }

    //ewen Kerbs still in progress
    public int[][][] BlockBuilder(SteineTyp type) throws FileNotFoundException {
        int[][][] size;
        switch(type)
        {
            case I:
                /* 3 dimensionales array um die rotations zu erkennen +  */
                size = new int[4][4][4];
                break;
            case O:
                size = new int[4][2][2];
                break;
            default:
                size = new int[4][3][3];
                break;
        }
        File file = new File("Steine/"+type+".txt");
        Scanner leser = new Scanner(file);
        //i= 4 verschiedene stein varianten (1=0° 2=90° 3=180°4=270°)
        for (int varianten = 0; varianten < 4 ; varianten++) {
            for (int j = 0; j < size[0].length; j++) {
                if(leser.hasNext())
                {
                    String[] srow = leser.next().split("");
                    int[] row = new int[size[0].length];
                    for (int k = 0; k <row.length; k++)
                    {
                        row[j]= Integer.valueOf(srow[j]);
                        size[varianten][j][k] =row[j];
                    }
                }
            }
        }
        return size;
    }

    public void rotate()
    {
        rotation++;
        if(rotation==4)
        {
            rotation=0;
        }
    }

    public void setX(int x) {
        this.x = x;
    }

    public void setY(int y) {
        this.y = y;
    }

    public void reset() {
        this.x = 2;
        this.y = 0;
        collision = false;

    }

    //Kollisons abfrage
    public void update() {
        if (collision) {
            for (int row = 0; row < coords.length; row++) {
                for (int col = 0; col < coords[0].length; col++) {
                    if (coords[row][col] != 0) {
                        board.getBoard()[y + row][x + col] = color;
                    }
                }
            }
            board.setCurrenStein();
            return;
        }

        boolean moveX=true;
        if (!(x + deltax + coords[0].length > 11) && !(x + deltax < 0)) {
            for (int row = 0; row < coords.length; row++) {
                for (int col = 0; col < coords[row].length; col++) {
                    if(coords[row][col] !=0) {
                        if (board.getBoard()[y + row][x + deltax + col] != null) {
                            moveX = true;
                        }
                    }
                }
            }
            if(moveX){
                x += deltax;
            }

        }

        deltax = 0;

        if (System.currentTimeMillis() - beginTime > delayTime) {
            if (!(y + 1+coords.length > BOARD_HEIGHT)) {
                for (int row = 0; row < coords.length; row++) {
                    for (int col = 0; col < coords[row].length; col++) {
                        if (coords[row][col] != 0){

                            if (board.getBoard()[y +1 + row][x - deltax + col] != null) {
                                collision = true;
                            }
                    }
                }
            }
            if (!collision) {
                y++;
            }

        } else {
            collision = true;
        }

        beginTime = System.currentTimeMillis();
    }

}
public void render(Graphics g){
    for(int row=0;row< coords.length;row++){
        for(int col = 0;col< coords[0].length;col++){
            if(coords[row][col] !=0){
                g.setColor(color);
                //
                g.fillRect(col*BLOCK_SIZE+x*BLOCK_SIZE,row*BLOCK_SIZE+y*BLOCK_SIZE,BLOCK_SIZE,BLOCK_SIZE);
            }
        }
    }
}

public void speedup(){
    delayTime=fast;
}
public void speedDown(){
    delayTime=normal;
}
public void moveRight(){
    deltax = 1;
    }
    public void moveLeft(){
        deltax = -1;
    }
}
